#ifndef idt_gdt_isr_h
#define idt_gdt_isr_h

#ifndef Private
 #define Private
 #endif
#ifndef Public
 #define Public
 #endif

#ifndef internal
 #ifdef Public
  #undef Public
 #endif
 #define Public extern
#endif


Public void init_idt_gdt();
Public void print_regs(regs_t r);

#define _keyboard
#define idt_gdt_proto
#define _irqs
#define _isrs
#define _idt
#define _gdt

#define static 
#ifdef idt_gdt_proto

#define _idt
#ifdef _idt
 typedef void (*isr_t)(regs_t);
 extern void idt_set_1();
 extern void idt_set_2(uint32);
  
 Public void *memset(void *s,int val,size_t size);
 Public void *memcpy(void *dest, void *src, size_t size);
 Public static void init_idt();
 Private static void idt_set_gate(uint8 pos,uint32 base,uint16 sel,uint8 flags);
 Private void interrupt_handler(regs_t regs);
 Private void isr_handler(regs_t regs);
 Public void remap_irqs();
 Public void send_EOI(int num);
 Public void set_irq_handler(int pos, isr_t handler);
 Public void set_isr_handler(int pos, isr_t handler);
 
#endif
#define _gdt
#ifdef _gdt
 extern void gdt_set_1();
 extern void gdt_set_2(uint32);
 
 Public void intit_idt_gdt();
 Public static void init_gdt();
 Private static void gdt_set_gate(int pos,uint32 base,uint32 limit,uint8 access,uint8 _granularity);
#endif
#define _isrs
#ifdef _isrs

  extern void _isr0();
  extern void _isr1();
  extern void _isr2();
  extern void _isr3();
  extern void _isr4();
  extern void _isr5();
  extern void _isr6();
  extern void _isr7();
  extern void _isr8();
  extern void _isr9();
  extern void _isr10();
  extern void _isr11();
  extern void _isr12();
  extern void _isr13();
  extern void _isr14();
  extern void _isr15();
  extern void _isr16();
  extern void _isr17();
  extern void _isr18();
  extern void _isr19();
  extern void _isr20();
  extern void _isr21();
  extern void _isr22();
  extern void _isr23();
  extern void _isr24();
  extern void _isr25();
  extern void _isr26();
  extern void _isr27();
  extern void _isr28();
  extern void _isr29();
  extern void _isr30();
  extern void _isr31();

#endif
#define _irqs
#ifdef _irqs
  extern void irq_0();
  extern void irq_1();
  extern void irq_2();
  extern void irq_3();
  extern void irq_4();
  extern void irq_5();
  extern void irq_6();
  extern void irq_7();
  extern void irq_8();
  extern void irq_9();
  extern void irq_10();
  extern void irq_11();
  extern void irq_12();
  extern void irq_13();
  extern void irq_14();
  extern void irq_15();

#endif

#endif

#define _timer
#ifdef _timer
  #ifdef internal
  extern unsigned long timer_ticks;
  extern int time_cur_pos;
  #endif
  
  Public static void timer_handler(regs_t regs);
  Public void init_timer(uint32 frequency);
  
#endif

#endif
