#include "include/common_includes.h"
#include "idt_gdt_isr.h"
#define internal//kernel_c
#include "kernel.h"
#define timer_freq 1
//#define enable_proceedings

uint64 timer_ticks=0;
int locked_text=0,time_cur_pos=0; //the position at which time has to be printed.
uchar *vidram=(uchar *)vdu_mem;

void kernel_main() 
{
	cls(screen_bcg_colour);
	set_cursor_pos(0);
	print_manuos();	
	init_hardware();    
	time_cur_pos=37+6+4+4+3;
	mprintf(newline" User@ManuOS // /broot//>",special_text_colour);
	mprintf(" Hello everyone :D ",screen_bcg_colour);
    while(1);
}

void init_hardware()
{
	asm ("sti"::);
	init_gdt();
	init_idt();
	mprintf(newline " Timer initiated at ",special_text_colour);//print_int(timer_freq,screen_bcg_colour);
	//init_timer(timer_freq);
	//mprintf(newline " Timer initiated at ",screen_bcg_colour);//print_int(timer_freq,screen_bcg_colour);
	//mprintf(" hz",screen_bcg_colour);	
}

void print_long_(unsigned long a)
{
	unsigned long tmp,aa;tmp=0;aa=0;
	tmp=a;
	while(tmp)
	{
		aa=(aa*10)+(tmp%10);
		tmp/=10;
	}
	while(aa)
	{
		outbyte((aa%10)+48);
		aa/=10;
	}
}

uchar in(ushort _port)
{
	uchar result;
	__asm__  ("in %%dx, %%al" : "=a" (result) : "d" (_port));
	return result;
}

void out(ushort _port, uchar _data)
{
	 __asm__ ("out %%al, %%dx" : :"a" (_data), "d" (_port));
}


#ifdef text_mode

#ifdef _welcome


void scroll_down(uint8 lines)
{/*
	int i;uint16 blank_pixl;
	blank_pixl=32|screen_bcg_colour;
	vidram=(uchar *) vdu_mem;
	for(i=0;i<80*24;i++)
	vidram[i] = vidram[i+160];
	*/
	/*for(i=24*80; i<25*80; i++) //for last line
	vidram[i] = blank_pixl;*/
	
	set_cursor_pos(to_offset(0,0));
	if(lines){}
}

void print_manuos()
{
	int a;
	set_cursor_pos(0);
	for(a=0;a<80;a++)
	 outbyte(0);
	set_cursor_pos(37);
	mprintf(name,special_text_colour);	
}

#endif

void mprintf(char *fmt,int colour)
{

	while(*fmt!='\0')
	{
		if((get_cursor_pos()/2)==((80*25*2)-1))
		{
			cls(screen_bcg_colour);
			set_cursor_pos((get_cursor_pos()/2)%80);
		}
		 if(*fmt==_sequence)/* . is used insted of \ hence /n instead of \n */
		{
			switch(*(fmt+1))
			{
				case 'b'://back space
				{
					move_cursor(-1);
					outbyte(0);
					move_cursor(-1);
					++fmt;
					break;
				}
				case 'r'://line feed
				{
					move_cursor(((get_cursor_pos()/2)%80)*-1);
					
					++fmt;
					break;
				}
				case 'n'://new line
				{
					move_cursor(80-((get_cursor_pos()/2)%80));
					
					++fmt;
					break;
				}
				case 't'://horizontal tab
				{
					move_cursor(4);
					++fmt;
					break;
				}
				default:
				{
					outpix_pos(*(++fmt),colour,get_cursor_pos());
				}				
			}
		}
	   else
	    outpix_pos(*fmt,colour,get_cursor_pos());
	    	   
	   fmt++;
	}
	
} 

#ifdef ui

void cls(int colour)
{
	int i;
	vidram=(uchar *)vdu_mem;
	for(i=0;i<=screen_size;i+=2)
	{
		*(vidram+i)=0;
		*(vidram+i+1)=(uchar)colour;//(uchar)screen_bcg_colour;
	}	
}

void update_cursor(uint16 position)
{
    outb(0x3D4, 0x0F);
    outb(0x3D5, (uchar)(position&0xFF));
    outb(0x3D4, 0x0E);
    outb(0x3D5, (uchar)((position>>8)&0xFF));
}

int get_cursor_pos()
{
	int offset;
	offset=vidram-(uchar *)vdu_mem;
	return offset;
}

void move_cursor(int distance)
{
   if(((get_cursor_pos()*2)+(distance*2))>locked_text)
    vidram+=distance*2;
   update_cursor(get_cursor_pos()/2);
}

void set_cursor_pos(int offset)
{
	if(offset>locked_text)
	vidram=(uchar *)vdu_mem+(offset*2);
	update_cursor(get_cursor_pos()/2);
}

int outbyte(uint8 c)
{
	unsigned short offset;
	unsigned char *vidmem = (unsigned char *)0xB8000;
	
	offset=get_cursor_pos();
	if(offset<(80*25*2))
	{
		if(c=='\r')
		 move_cursor(-1*((offset/2)%80));
		if(c=='\n')
		{
			move_cursor(80);
			move_cursor(-1*((offset/2)%80));//outbyte('\r');
		}
		if(c=='\b')
		 move_cursor(-1);
		vidmem+=offset;
		*vidmem =c;
		move_cursor(1);
	}

	return 0;
}


int outpix_pos(int c,int colour,int offset)
{
	outbyte(c);
	_outc_bcg_pos(colour,offset);
	return 0;
}


void _outc_bcg_pos(int colour, int offset)//output a colour to the background/ text attribute(not text) at specified position
{
	uchar *v_mem=(uchar *)vdu_mem;
	if(offset%2==0)
	   *(v_mem+1+offset)=(uchar)colour;
	else
       *(v_mem+offset)=(uchar)colour;

}

#endif


#endif

void secDelay(int secs)
{
	milliDelay(1000*secs);
}
void milliDelay(long millisecs)
{

	microDelay(1000*millisecs);
}

void microDelay(unsigned long microsecs)
{
	unsigned long a;
	for(a=1;a<=microsecs*500;a++)
	 {
		// tinydelay(10);
	 }
}
